unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    btHwnd: TButton;
    btDC: TButton;
    LsBxInfoEcran: TListBox;
    btInfos: TButton;
    procedure btHwndClick(Sender: TObject);
    procedure btDCClick(Sender: TObject);
    procedure btInfosClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btHwndClick(Sender: TObject);
{Objectif :Explication d'un Handle Fentre et une petite dmonstration d'une
           fonction API qui ncessite cette valeur pour s'effectuer.}
Var
   Hwnd :HWND;  {Handle fentre rcuprer par la fonction WindowFromDC(); }
begin
     {Affichage du Handle fentre avec la proprit Handle d'un composant
      fentr.}
     MessageBox( 0, PChar('Voici mon adresse fentre : ' +
                           IntToStr(Form1.Handle)
                           + #13 + #13
                           + 'C''est par cette adresse que Windows me '
                           + 'retrouve parmis les autres fentres qu''il '
                           + 'a  s''occuper'), 'Hwnd',
                           MB_OK + MB_ICONINFORMATION );


     {Affichage du Handle fentre avec une fonction API}
     { l'aide du DC (Contexte Graphique) de la fntre nous sommes
      capables de rcuprer son Handle fentre.}
     Hwnd := WindowFromDC( Form1.Canvas.Handle );
     MessageBox( 0, PChar('Et encore mon Handle fentre : '
                           + IntToStr(Hwnd) + #13 +#13),
                           'DC', MB_OK + MB_ICONINFORMATION );

     {Dmonstration d'une fonction API utilisant l'Handle fentre}
     SetWindowText( Form1.Handle, 'Voici mon nouveau titre...' );
end;

procedure TForm1.btDCClick(Sender: TObject);
{Objectif :Explication d'un Handle Graphique et une petite dmonstration d'une
           fonction API qui ncessite cette valeur pour s'effectuer.}
Var
   hDC :HDC; {Contexte graphique de l'cran mme}
begin
     {Affichage du Handle fentre avec la proprit Handle du Canvas.}
     MessageBox( 0, PChar('Voici mon adresse fentre : ' +
                           IntToStr(Form1.Canvas.Handle)
                           + #13 + #13
                           + 'C''est  l''aide de cette adresse qu''il est '
                           + 'est possible d''utiliser mes capacits '
                           + 'graphiques'), 'DC', MB_OK + MB_ICONINFORMATION );

     {Affichage du Handle graphique (DC) avec une fonction API.
     Cette fonction est plus pratique que GetDC, pour rcuprer le DC d'une
     fentre car elle rcupre tout la fentre donc la barre de titre aussi,
     plus pratique pour faire des dgrads ou dessiner sur cette barre de
     titre.}
     hDC := GetWindowDC( Form1.Handle );
     MessageBox( 0, PChar('Encore le DC de la fentre : ' +
                           IntToStr(hDC)),
                           'DC',
                           MB_OK + MB_ICONINFORMATION );

     {Important :
      Aprs avoir rcuprer un Contexte graphique avec la fonction GetDC,
      il faut toujours le relcher  l'aide de cette fonction.}
     ReleaseDC( 0, hDC );


     {Dmonstration d'une fonction API utilisant l'Handle graphique (DC)}
     {Changement des attributs graphique du DC de ma fentre}
     Form1.Canvas.Brush.Style := bsDiagCross;  //Type de dessin
     Form1.Canvas.Brush.Color := clBlue;       //Couleur de fond
     Form1.Canvas.Pen.Style := psDash;         //Type de contour
     Form1.Canvas.Pen.Color := clRed;          //Couleur de contour

     {Fonction API}
     If Not RoundRect( Form1.Canvas.Handle, 5, 5, 305, 30, 10, 10 ) Then
        ShowMessage('Erreur');

end;

procedure TForm1.btInfosClick(Sender: TObject);
{Objectif : l'aide du DC de l'cran, nous allons rcuprer quelques
           infos parfois utiles}
Var
   hDCEcran :HDC;  {Contexte graphique de l'cran}
begin
     {Pour rcuprer le Handle de l'cran, juste pass 0 comme argument}
     hDCEcran := GetDC( 0 );

     {Vide la liste}
     LsBxInfoEcran.Items.Clear;

     {Ajout des infos}
     LsBxInfoEcran.Items.Add( 'Largeur en millimtres : '
                              + IntToStr( GetDeviceCaps( hDCEcran, HORZSIZE ))
                              + 'mm');
     LsBxInfoEcran.Items.Add( 'Hauteur en millimtres : '
                              + IntToStr( GetDeviceCaps( hDCEcran, VERTSIZE ))
                              + 'mm');
     LsBxInfoEcran.Items.Add( '' );

     LsBxInfoEcran.Items.Add( 'Largeur en Pixels : '
                              + IntToStr( GetDeviceCaps( hDCEcran, HORZRES ))
                              + 'px');
     LsBxInfoEcran.Items.Add( 'Hauteur en lignes de trame: '
                              + IntToStr( GetDeviceCaps( hDCEcran, VERTRES ))
                              + ' Lignes');
     LsBxInfoEcran.Items.Add( '' );

     LsBxInfoEcran.Items.Add( 'Nombre de pixel par pouce en largeur : '
                              + IntToStr( GetDeviceCaps( hDCEcran, LOGPIXELSX ))
                              + 'px');
     LsBxInfoEcran.Items.Add( 'Nombre de pixel par pouce en hauteur : '
                              + IntToStr( GetDeviceCaps( hDCEcran, LOGPIXELSY ))
                              + 'px');
     LsBxInfoEcran.Items.Add( '' );

     LsBxInfoEcran.Items.Add( 'Nombre de bit(s) par pixels : '
                              + IntToStr( GetDeviceCaps( hDCEcran, BITSPIXEL ))
                              + ' bit(s)');
     LsBxInfoEcran.Items.Add( '' );

     {Relcher le DC}
     ReleaseDC( GetDC( 0 ), hDCEcran );

end;

end.
